<?php

namespace Drupal\entity_router\Response;

use Drupal\Core\Entity\EntityInterface;
use Symfony\Component\HttpFoundation\Response;

/**
 * The entity response for further processing.
 *
 * @see \Drupal\entity_router\EventSubscriber::onResponse()
 */
class EntityResponse extends Response {

  /**
   * {@inheritdoc}
   */
  public function __construct(
    public readonly ?EntityInterface $entity,
    public readonly string $format,
    int $status,
  ) {
    parent::__construct('', $status);
  }

  /**
   * {@inheritdoc}
   *
   * @deprecated Use public property.
   */
  public function getEntity(): ?EntityInterface {
    @\trigger_error(__METHOD__ . '() is deprecated in entity_router:3.0.0 and will be removed in entity_router:4.0.0', \E_USER_DEPRECATED);
    return $this->entity;
  }

  /**
   * {@inheritdoc}
   *
   * @deprecated Use public property.
   */
  public function getFormat(): string {
    @\trigger_error(__METHOD__ . '() is deprecated in entity_router:3.0.0 and will be removed in entity_router:4.0.0', \E_USER_DEPRECATED);
    return $this->format;
  }

}
